package com.company.demo1.view.childentity;

import com.company.demo1.entity.ChildEntity;

import com.company.demo1.entity.SerialNum;
import com.company.demo1.entity.Type;
import com.company.demo1.service.SerialNumService;
import com.company.demo1.view.main.MainView;

import com.vaadin.flow.router.Route;
import io.jmix.flowui.component.combobox.JmixComboBox;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

@Route(value = "childEntities/:id", layout = MainView.class)
@ViewController("demo1_ChildEntity.detail")
@ViewDescriptor("child-entity-detail-view.xml")
@EditedEntityContainer("childEntityDc")
public class ChildEntityDetailView extends StandardDetailView<ChildEntity> {
    @Autowired
    private SerialNumService serialNumService;
    @ViewComponent
    private JmixComboBox<String> snField;
    private String type;

    public void setType(String type) {
        this.type = type;
    }

    @Subscribe
    public void onInit(final InitEvent event) {
        //在该方法中type是为空的,
        List<String> rnList = serialNumService.getRnListByType(type);
        snField.setItems(rnList);
    }

    /**
     * 保存实体的时候，会报该错误Edited entity isn't initialized yet
     *
     */



}